// File: EXMPL1.C
// Sept. 6, 2018
//
//  IOTDemo MyMENSCH, Keypad, Hitachi LCD, Laird RM191 LoRa/BLE
//	by WDC 
//

#include <stdio.h>

//pragma TITLE
//pragma STTL

#if USING_02
#else
#asm
		EXIT         "Not Valid Processor: Use -DUSING_816, etc. ! ! ! ! ! ! ! ! ! ! ! !"
#endasm
#endif
#asm
			title  "W65C165i1 'C' Compiler IOTDemo for MyMENSCH"
			sttl
#endasm


// ****************************************************************************
// ****************************************************************************
// End of testing for proper Command line Options for Compiling of this program
// ****************************************************************************
// ****************************************************************************


/* BEGIN_FILE_HDR
********************************************************************************
                               E X M P L 1 . C
********************************************************************************
********************************************************************************
* FILE NAME: IOTDemo.c
*
* TITLE: 'C' EXAMPLE
*
*  DATA_RIGHTS: Western Design Center
*               Copyright(C) 1978-2018
*               All rights reserved. Reproduction in any manner, 
*               in whole or in part, is strictly prohibited without
*               the prior written approval of The Western Design Center, Inc.
*
* DESCRIPTION:
*	This is a simple IoT Demo using:
*	MyMENSCH, Keypad, Hitachi LCD, Laird RM191 LoRa/BLE
*	Sends FPGA temperature from onboard TSD to LoRa Gateway
*      
*      
*
*
* DEFINED FUNCTIONS:
*     msdelay()
*        - Delay
*     IRQHandler()
*        - VIA Timer Interrupt Handler
*     check_endof_memory()
*        - 
*
* SPECIAL CONSIDERATIONS:
*      Note: Use // as a comment so that we can comment out blocks by using 'slash'* *'slash'
*     
*
* AUTHOR: WDC
*
* CREATION DATE: Sep 06, 2018
*
* REVISION HISTORY
*     Name           Date       Description
*     ------------   ---------  ------------------------------------------------
*     D.Gray   09/06/2018 Initial
*
********************************************************************************
 END_FILE_HDR */

/*
 *============================= DEFINITION INCLUDES ============================
 *           ( listing of all header files having data types, and con-
 *             stants, but no function prototypes used by this module )
 */
   /* <None> */


/*
 *============================ FUNCTION INCLUDES ===============================
 *     ( listing of all header files having prototypes, data types, and
 *       constants used by this module. In addition, list all the func-
 *       tions used by this module below the appropriate header file. )
 */


// define some unsigned types

typedef unsigned char uchar;
typedef unsigned short ushort;
typedef unsigned long ulong;


void IRQHandler( void );
//static void msdelay( ushort ms );
uchar sum(uchar a, uchar b);
extern void START( void );


/*
 *================================= INPUTS =====================================
 *   (listing of all global variables "read" but not modified by this module)
 */
   /* <None> */



/*
 *================================= OUTPUTS ====================================
 *   (listing of all global variables "modified" but not read by this module)
 */

   /* <None> */


/*
 *================================= UPDATES ====================================
 *   (listing of all global variables "read" and "modified" by this module)
 */

//int delay = 20;


/*
 *======================= PRIVATE CONSTANTS and MACROS =========================
 *       (listings of all constants and macros used by this module)
 */



// this is the clock rate on the board

#define	CLK_RATE	14745600 		; 14.7456 MHZ

// these are the addresses of the W65C22S part
// note that the 'volatile' declaration forces the compiler to use
// a single byte read instead of the more efficient two byte read

			//***************************
			// VIA Specific Registers
			//***************************
#define	VIA_ORB		*( volatile uchar * )0x7F20
#define	VIA_IRB		*( volatile uchar * )0x7F20
#define	VIA_ORA		*( volatile uchar * )0x7F21
#define	VIA_IRA		*( volatile uchar * )0x7F21
#define	VIA_DDRB	*( volatile uchar * )0x7F22
#define	VIA_DDRA	*( volatile uchar * )0x7F23
#define	VIA_T1CLO	*( volatile uchar * )0x7F24
#define	VIA_T1CHI	*( volatile uchar * )0x7F25
#define	VIA_T1LLO	*( volatile uchar * )0x7F26
#define	VIA_T1LHI	*( volatile uchar * )0x7F27
#define	VIA_T2CLO	*( volatile uchar * )0x7F28
#define	VIA_T2CHI	*( volatile uchar * )0x7F29
#define	VIA_SR		*( volatile uchar * )0x7F2A
#define	VIA_ACR		*( volatile uchar * )0x7F2B
#define	VIA_PCR		*( volatile uchar * )0x7F2C
#define	VIA_IFR		*( volatile uchar * )0x7F2D
#define	VIA_IER		*( volatile uchar * )0x7F2E
#define	VIA_ORANH	*( volatile uchar * )0x7F2F
#define	VIA_IRANH	*( volatile uchar * )0x7F2F

			//***************************
			// GPIOB Specific Registers
			//***************************
#define	GPIOB_DATA		*( volatile uchar * )0x7F08
#define	GPIOB_DDR		*( volatile uchar * )0x7F09

//***********************************************
//  Functions
//***********************************************

void IRQHandler( void )
{

}

uchar sum(uchar a, uchar b) 
{
	uchar sum = a + b;
	return sum;
}


/******************************************************
                 End of IoTDEMO.C
*******************************************************/

